# ----------------------------------------------------------------------------------------------
# ------------------- Importance of security assurance by Roles in project ---------------------
# ----------------------------------------------------------------------------------------------
fossanalyze.importance_roles <- function (saveFile=FALSE, projectType = "web", file="importance") {

# Plot constants 
if(projectType == "web") {
    projectTypeText <- "WEB INFORMATION systems"
    projectTypeInd <- 1
    fileName <- paste(file, "_web", sep = "")
} else if(projectType == "sys") {
    projectTypeText <- "SYSTEMS or INFRASTRUCTURES"
    projectTypeInd <- 2
    fileName <- paste(file, "_sys", sep = "")
} else {
    projectTypeText <- "OTHER projects"
    projectTypeInd <- 3
    fileName <- paste(file, "_other", sep = "")
}

nmr <- foss$CB_MAIN_ROLES                 [foss$RB_TYPE_OF_PROJECT %in% grep(projTypes[projectTypeInd], foss$RB_TYPE_OF_PROJECT, value=TRUE)]
nmi <- foss$RB_CONSIDER_SECURITY_IMPORTANT[foss$RB_TYPE_OF_PROJECT %in% grep(projTypes[projectTypeInd], foss$RB_TYPE_OF_PROJECT, value=TRUE)]

nm <-list()
nm$CB_MAIN_ROLES <- nmr
nm$RB_CONSIDER_SECURITY_IMPORTANT <- nmi

nmBugreporter <- nm$RB_CONSIDER_SECURITY_IMPORTANT[nm$CB_MAIN_ROLES %in% grep(roles[1], nm$CB_MAIN_ROLES, value=TRUE)]
nmDeveloper   <- nm$RB_CONSIDER_SECURITY_IMPORTANT[nm$CB_MAIN_ROLES %in% grep(roles[2], nm$CB_MAIN_ROLES, value=TRUE)]
nmDocumenter  <- nm$RB_CONSIDER_SECURITY_IMPORTANT[nm$CB_MAIN_ROLES %in% grep(roles[3], nm$CB_MAIN_ROLES, value=TRUE)]
nmMaintainer  <- nm$RB_CONSIDER_SECURITY_IMPORTANT[nm$CB_MAIN_ROLES %in% grep(roles[4], nm$CB_MAIN_ROLES, value=TRUE)]
nmTester      <- nm$RB_CONSIDER_SECURITY_IMPORTANT[nm$CB_MAIN_ROLES %in% grep(roles[5], nm$CB_MAIN_ROLES, value=TRUE)]
nmOther       <- nm$RB_CONSIDER_SECURITY_IMPORTANT[nm$CB_MAIN_ROLES %in% grep(roles[6], nm$CB_MAIN_ROLES, value=TRUE)]

mainText <- paste("Relevance of security for ", projectTypeText, ".", sep = "")
ylabText <- percenText;
xlabText <- "Relevance of security";
legendLab <- roles

#Normirung Maximal Wert
normMax <- 100

nmBugreporterLen <- length(nmBugreporter)
nmDeveloperLen <- length(nmDeveloper)
nmDocumenterLen <- length(nmDocumenter)
nmMaintainerLen <- length(nmMaintainer)
nmTesterLen <- length(nmTester)
nmOtherLen <- length(nmOther)

importance_1 <- c( length(nmBugreporter[nmBugreporter %in% grep(importance[1], nmBugreporter, value=TRUE)])/nmBugreporterLen*normMax, 
		   length(nmDeveloper[nmDeveloper %in% grep(importance[1], nmDeveloper, value=TRUE)])/nmDeveloperLen*normMax, 
		   length(nmDocumenter[nmDocumenter %in% grep(importance[1], nmDocumenter, value=TRUE)])/nmDocumenterLen*normMax, 
		   length(nmMaintainer[nmMaintainer %in% grep(importance[1], nmMaintainer, value=TRUE)])/nmMaintainerLen*normMax, 
		   length(nmTester[nmTester %in% grep(importance[1], nmTester, value=TRUE)])/nmTesterLen*normMax, 
		   length(nmOther[nmOther %in% grep(importance[1], nmOther, value=TRUE)])/nmOtherLen*normMax 
		  )

importance_2 <- c( length(nmBugreporter[nmBugreporter %in% grep(importance[2], nmBugreporter, value=TRUE)])/nmBugreporterLen*normMax, 
		   length(nmDeveloper[nmDeveloper %in% grep(importance[2], nmDeveloper, value=TRUE)])/nmDeveloperLen*normMax, 
		   length(nmDocumenter[nmDocumenter %in% grep(importance[2], nmDocumenter, value=TRUE)])/nmDocumenterLen*normMax, 
		   length(nmMaintainer[nmMaintainer %in% grep(importance[2], nmMaintainer, value=TRUE)])/nmMaintainerLen*normMax, 
		   length(nmTester[nmTester %in% grep(importance[2], nmTester, value=TRUE)])/nmTesterLen*normMax, 
		   length(nmOther[nmOther %in% grep(importance[2], nmOther, value=TRUE)])/nmOtherLen*normMax 
		  )

importance_3 <- c( length(nmBugreporter[nmBugreporter %in% grep(importance[3], nmBugreporter, value=TRUE)])/nmBugreporterLen*normMax, 
		   length(nmDeveloper[nmDeveloper %in% grep(importance[3], nmDeveloper, value=TRUE)])/nmDeveloperLen*normMax, 
		   length(nmDocumenter[nmDocumenter %in% grep(importance[3], nmDocumenter, value=TRUE)])/nmDocumenterLen*normMax, 
		   length(nmMaintainer[nmMaintainer %in% grep(importance[3], nmMaintainer, value=TRUE)])/nmMaintainerLen*normMax, 
		   length(nmTester[nmTester %in% grep(importance[3], nmTester, value=TRUE)])/nmTesterLen*normMax, 
		   length(nmOther[nmOther %in% grep(importance[3], nmOther, value=TRUE)])/nmOtherLen*normMax 
		  )

importance_4 <- c( length(nmBugreporter[nmBugreporter %in% grep(importance[4], nmBugreporter, value=TRUE)])/nmBugreporterLen*normMax, 
		   length(nmDeveloper[nmDeveloper %in% grep(importance[4], nmDeveloper, value=TRUE)])/nmDeveloperLen*normMax, 
		   length(nmDocumenter[nmDocumenter %in% grep(importance[4], nmDocumenter, value=TRUE)])/nmDocumenterLen*normMax, 
		   length(nmMaintainer[nmMaintainer %in% grep(importance[4], nmMaintainer, value=TRUE)])/nmMaintainerLen*normMax, 
		   length(nmTester[nmTester %in% grep(importance[4], nmTester, value=TRUE)])/nmTesterLen*normMax, 
		   length(nmOther[nmOther %in% grep(importance[4], nmOther, value=TRUE)])/nmOtherLen*normMax 
		  )

# construct values vector
importanceVector <- c(importance_1, importance_2, importance_3, importance_4)

lenVector <- c(nmBugreporterLen, nmDeveloperLen, nmDocumenterLen, nmMaintainerLen, nmTesterLen, nmOtherLen)
legendLab <- paste (legendLab, " (",  lenVector,  " part.)", sep="")

# construct matrix to plot
plotMatrix <- matrix(importanceVector,
                nrow = length(roles), ncol = length(importance), byrow = FALSE,
                dimnames = list(legendLab, importanceLab))

# if "saveFile", than save as png image:
if (saveFile) png(paste(fileName, "png", sep="."), width=700, height=700)

#Plot parameters
par(mai = c(0.9, 0.9, 0.7, 0)) # margin size (bottom, left, top, right) specified in inches. 
par(mgp = c(3.5, 2, 0)) # margin line for (the axis title, axis labels, axis line)
par(cex.lab = 1.3) # label size 

#Draw Plot
barplot(plotMatrix, beside = TRUE, cex.names = 1.0, axis.lty = 0,
        col=c(hcl(h = c(120, 210, 300), c = 20, l = 90, fixup = FALSE),"indianred","darkgray", "mintcream"),
        main=mainText, ylab=ylabText, xlab=xlabText,
        legend = rownames(plotMatrix),
        ylim = c(0, normMax))
grid(0, 10)

# if "saveFile", stop output-redirection to file
if (saveFile) dev.off()

}

#Function call with different parameters
isSaveFile <- TRUE
fossanalyze.importance_roles(isSaveFile, "web")
fossanalyze.importance_roles(isSaveFile, "sys")
fossanalyze.importance_roles(isSaveFile, "other")
